structure Num
   0 : Num
   succ : Num -> Num

function plus : Num,Num -> Num
  plus(0, y) = y
  plus(succ(x), y) = succ(plus(x, y))
  
function times : Num,Num -> Num
  times(0, y) = 0
  times(succ(x), y) = plus(y, times(x, y))
  
function exp : Num,Num -> Num
  exp(x, 0) = succ(0)
  exp(x, succ(y)) = times(x, exp(x, y))
  
function pred : Num -> Num
  pred(0) = 0
  pred(succ(x)) = x

function minus : Num,Num -> Num 
  minus(x,0) = x
  minus(x,succ(y)) = minus(pred(x),y)

function ge : Num,Num -> bool
  ge(x,0) = true
  ge(0,succ(y))= false
  ge(succ(x),succ(y)) = ge(x,y)

function le : Num,Num -> bool
  le(0,x) = true
  le(succ(x),0)= false
  le(succ(x),succ(y)) = le(x,y)


function even : Num -> bool
  even(0) = true
  even(succ(0))=false
  even(succ(succ(x))) = even(x)

function double : Num -> Num
  double(0)=0
  double(succ(X)) = succ(succ(double(X)))

function half : Num -> Num
  half(0)=0
  half(succ(0))=0
  half(succ(succ(x)))=half(x)
