module ConfigureMe (create,HTML) where

type HTML = String

-- creates from a title, a left and right neighbor, a parent and a list children
-- a corresponding navigation bar
-- change everything you like

--        path      titel     left      right         parents          children(titel,path)
create :: String -> String -> String -> String -> [(String,String)] -> [(String,String)] -> HTML
create path titel lft rght prent cildren = titleBar (left d lft) titel (right d rght) ++ intable (parent d prent) titel childTxts ++"\n"
    where d = length (filter ('.' ==) path) -- the depth
	  childTxts = map (children d) cildren


intable :: String -> String -> [String] -> String
intable parents title children =
    let first = "<TABLE>\n<TR><TD>" ++ parents ++ "</TD><TD><B>" ++ title ++ "</B></TD></TR>\n"
	middle [] = ""
	middle (x:xs) = "<TR><TD></TD><TD>" ++ "&#" ++ show (if (length xs == 0) then 0x2514 else 0x251c) ++ ";  " ++ x ++ "</TD></TR>\n" ++ middle xs
	last = "</TABLE>"
	
	in first ++ middle children ++ last


titleBar :: String -> String -> String -> HTML
titleBar l t r = "<TABLE width=\"100%\"><TR>\n" ++
		 "<TD align=left width=28>" ++ l ++ "</TD>\n" ++
		 "<TD align=center><H1>" ++ t ++ "</H1></TD>\n" ++
		 "<TD align=right width=28>" ++ r ++ "</TD>\n" ++
		 "</TR></TABLE>\n"

left, right :: Int -> String -> HTML
left d = imageLinkToHTML d "left.gif" "left"
right d = imageLinkToHTML d "right.gif" "right"


--        depth   parents             
parent :: Int -> [(String,String)] -> HTML
parent _ [] = ""
parent d xs = 
    let list = map (\ (title,path) -> linkToHTML d title path ++ " &rarr; ") xs
      in concat (reverse list) 

children :: Int -> (String,String) -> HTML
children d (t,p) = linkToHTML d t p 


--            depth  label     ref       HTML
linkToHTML :: Int -> String -> String -> HTML
linkToHTML d s ref =
   let file = concat (replicate d "../") ++ (map ( \x -> if x == '.' then '/' else x ) ref) ++ ".html"
     in ("<a href=\"" ++ file ++"\">"++s++"</a>")

--                 depth  image     alt       ref       HTML
imageLinkToHTML :: Int -> String -> String -> String -> HTML
imageLinkToHTML d s alt ref =
   let depthStr = concat (replicate d "../")
       file = depthStr ++ (map ( \x -> if x == '.' then '/' else x ) ref) ++ ".html"
       image = depthStr ++ "images/"++s
     in ("<a href=\"" ++ file ++"\"><img src=\""++image++"\" alt=\""++alt++"\"></a>\n")
