import java.io.*;
import java.net.*;
import memquery.*;

public class BenchMain {

	/*
	private static String baseURL = "http://porthos:8001/";
	private static String servHostname = "porthos";
	*/
	
	private static String[] benchFiles = {
		"Overview.html"
		/*
		"background.gif",
		"Doc/background.gif",
		"Doc/Programmer/addmovie.gif",
		"Doc/Programmer/algo-lookup.gif",
		"Doc/Programmer/algo-perform.gif",
		"Doc/Programmer/background.gif",
		"Doc/Programmer/design.gif",
		"Doc/Programmer/dir-output.gif",
		"Doc/Programmer/file-output.gif",
		"Doc/Programmer/framed-output.gif",
		"Doc/Programmer/jspbeandb.gif",
		"Doc/Programmer/olddesign.gif",
		"Doc/Programmer/perform.gif",
		"Doc/Programmer/resframe.gif",
		"Doc/Programmer/resource.gif",
		"Doc/Programmer/rsm.gif",
		"Doc/Programmer/samples/background.gif",
		"Doc/Programmer/searchmovie.gif",
		"Doc/Reference/background.gif",
		"Doc/style/background.gif",
		"Doc/User/background.gif",
		"Doc/User/control-admin.gif",
		"Doc/User/control-button.gif",
		"Doc/User/control-http.gif",
		"Doc/User/images/auth1.gif",
		"Doc/User/images/auth2.gif",
		"Doc/User/images/auth3.gif",
		"Doc/User/images/auth4.gif",
		"Doc/User/images/auth5.gif",
		"Doc/User/images/auth6.gif",
		"Doc/User/images/cgi.gif",
		"Doc/User/images/cocooncfg.gif",
		"Doc/User/images/conf-attrs.gif",
		"Doc/User/images/davauth.gif",
		"Doc/User/images/davindexer.gif",
		"Doc/User/images/indexers1.gif",
		"Doc/User/images/indexers2.gif",
		"Doc/User/images/indexers3.gif",
		"Doc/User/images/indexers4.gif",
		"Doc/User/images/indexers5.gif",
		"Doc/User/images/indexers6.gif",
		"Doc/User/images/indexers7.gif",
		"Doc/User/images/indexers8.gif",
		"Doc/User/images/indexers9.gif",
		"Doc/User/images/labelbureau.gif",
		"Doc/User/images/proxy1.gif",
		"Doc/User/images/proxy2.gif",
		"Doc/User/images/proxy2b.gif",
		"Doc/User/images/proxy3.gif",
		"Doc/User/images/proxy4.gif",
		"Doc/User/images/proxy5.gif",
		"Doc/User/images/proxy6.gif",
		"Doc/User/images/proxy7.gif",
		"Doc/User/images/put1.gif",
		"Doc/User/images/put10.gif",
		"Doc/User/images/put11.gif",
		"Doc/User/images/put2.gif",
		"Doc/User/images/put3.gif",
		"Doc/User/images/put4.gif",
		"Doc/User/images/put5.gif",
		"Doc/User/images/put6.gif",
		"Doc/User/images/put7.gif",
		"Doc/User/images/put8.gif",
		"Doc/User/images/put9.gif",
		"Doc/User/images/servlet-indexer1.gif",
		"Doc/User/images/servlet-indexer2.gif",
		"Doc/User/images/servlet-props.gif",
		"Doc/User/images/servlet1.gif",
		"Doc/User/images/servlet2.gif",
		"Doc/User/images/servlet3.gif",
		"Doc/User/images/servlet4.gif",
		"Doc/User/images/servlet5.gif",
		"Doc/User/images/servlet6.gif",
		"Doc/User/images/virtual1.gif",
		"Doc/User/images/virtual2.gif",
		"Doc/User/images/virtual3.gif",
		"Doc/User/images/virtual4.gif",
		"Doc/User/images/virtual5.gif",
		"Doc/User/images/virtual6.gif",
		"Doc/User/images/virtual7.gif",
		"Doc/User/images/virtual8.gif",
		"Doc/User/images/virtual9.gif",
		"Doc/User/images/zip1.gif",
		"Doc/User/images/zip2.gif",
		"Doc/User/images/zip3.gif",
		"Doc/User/images/zip4.gif",
		"Doc/User/images/zip5.gif",
		"Doc/User/images/zip6.gif",
		"Doc/User/jigadm1.gif",
		"Doc/User/jigadm2.gif",
		"Doc/User/jigadm3.gif",
		"Doc/User/jigadm4.gif",
		"Doc/User/jigadmauth.gif",
		"Doc/User/JigAdmin/background.gif",
		"Doc/User/JigAdmin/images/addrealm.gif",
		"Doc/User/JigAdmin/images/addres.gif",
		"Doc/User/JigAdmin/images/adduser.gif",
		"Doc/User/JigAdmin/images/attrs.gif",
		"Doc/User/JigAdmin/images/auth.gif",
		"Doc/User/JigAdmin/images/big.gif",
		"Doc/User/JigAdmin/images/commit.gif",
		"Doc/User/JigAdmin/images/dnd.gif",
		"Doc/User/JigAdmin/images/docs_space.gif",
		"Doc/User/JigAdmin/images/drag_cursor.gif",
		"Doc/User/JigAdmin/images/edit_id.gif",
		"Doc/User/JigAdmin/images/expanded.gif",
		"Doc/User/JigAdmin/images/folder.gif",
		"Doc/User/JigAdmin/images/fpopup.gif",
		"Doc/User/JigAdmin/images/framemenu.gif",
		"Doc/User/JigAdmin/images/ftree.gif",
		"Doc/User/JigAdmin/images/indexers.gif",
		"Doc/User/JigAdmin/images/j_add.gif",
		"Doc/User/JigAdmin/images/j_close.gif",
		"Doc/User/JigAdmin/images/j_delete.gif",
		"Doc/User/JigAdmin/images/j_edit.gif",
		"Doc/User/JigAdmin/images/j_file.gif",
		"Doc/User/JigAdmin/images/j_help.gif",
		"Doc/User/JigAdmin/images/j_reference.gif",
		"Doc/User/JigAdmin/images/j_reindex.gif",
		"Doc/User/JigAdmin/images/j_save.gif",
		"Doc/User/JigAdmin/images/j_stop.gif",
		"Doc/User/JigAdmin/images/menu.gif",
		"Doc/User/JigAdmin/images/minibrowser.gif",
		"Doc/User/JigAdmin/images/node.gif",
		"Doc/User/JigAdmin/images/popupmenu.gif",
		"Doc/User/JigAdmin/images/properties.gif",
		"Doc/User/JigAdmin/images/realms.gif",
		"Doc/User/JigAdmin/images/resedit.gif",
		"Doc/User/JigAdmin/images/reset.gif",
		"Doc/User/JigAdmin/images/slist.gif",
		"Doc/User/JigAdmin/images/small.gif",
		"Doc/User/JigAdmin/images/toolbar.gif",
		"Doc/User/JigAdmin/images/tree.gif",
		"Doc/User/JigAdmin/images/userattrs.gif",
		"Doc/User/JigAdmin/images/wmenu.gif",
		"Doc/User/jigadmin5.gif",
		"Doc/User/jigedit1.gif",
		"Doc/User/jigedit2.gif",
		"Doc/User/jigedit3.gif",
		"Doc/User/jigedit4.gif",
		"Doc/User/load.gif",
		"Doc/User/PageCompilation/background.gif",
		"Doc/User/PageCompilation/images/jhtml-props.gif",
		"Doc/User/PageCompilation/images/jhtml-test1.gif",
		"Doc/User/PageCompilation/images/jhtml-test2.gif",
		"Doc/User/PageCompilation/post.gif",
		"Doc/User/PageCompilation/posted.gif",
		"icons/32x32/caution.gif",
		"icons/arch-rot.gif",
		"icons/arch.gif",
		"icons/archive.gif",
		"icons/back.gif",
		"icons/binary.gif",
		"icons/binhex.gif",
		"icons/blank.gif",
		"icons/broken.gif",
		"icons/burst.gif",
		"icons/caution.gif",
		"icons/comp1.gif",
		"icons/comp2.gif",
		"icons/compressed.gif",
		"icons/continued.gif",
		"icons/dir.gif",
		"icons/dir2.gif",
		"icons/dir_closed.gif",
		"icons/dir_opened.gif",
		"icons/doc48x.gif",
		"icons/fold.gif",
		"icons/fold2.gif",
		"icons/foldall.gif",
		"icons/forward.gif",
		"icons/generic.gif",
		"icons/generic2.gif",
		"icons/generic3.gif",
		"icons/green-ball.gif",
		"icons/greenball.gif",
		"icons/image.gif",
		"icons/image2.gif",
		"icons/index.gif",
		"icons/jigsaw.gif",
		"icons/left.gif",
		"icons/mail4.gif",
		"icons/mailto.gif",
		"icons/movie.gif",
		"icons/rainbow.gif",
		"icons/red-ball.gif",
		"icons/right.gif",
		"icons/sleft.gif",
		"icons/sound.gif",
		"icons/sound2.gif",
		"icons/sright.gif",
		"icons/tar.gif",
		"icons/text.gif",
		"icons/transfer.gif",
		"icons/unfold.gif",
		"icons/unfold2.gif",
		"icons/unknown.gif",
		"icons/uu.gif",
		"icons/w3c_48x48.gif",
		"icons/w3c_home.gif",
		"icons/w3c_main.gif",
		"icons/WWW/new_red.gif",
		"icons/WWW/relnotes48x.gif",
		"icons/WWW/up.gif",
		"icons/WWW/w3c_home.gif",
		"icons/yellow-ball.gif",
		"style/background.gif"
			*/
	};

	static boolean debug = false;
	private static void debprint(String s) {
		if (debug) {
			System.err.println(s);
		}
	}

	private static int buffsize = 1000;
	static int getPage(String servHostname, String baseURL, int n) {
		HttpURLConnection conn = null;
		try {
			byte[] buffer = new byte[buffsize];
			URL pageURL = new URL(baseURL + benchFiles[n]);
			conn = (HttpURLConnection)pageURL.openConnection();
			conn.connect();

			InputStream content = conn.getInputStream();
			debprint("SUCCESS " + benchFiles[n]); 

			int x;
			do {
				x = content.read(buffer);
			} while (x>0);
			return 1;

		}
		catch (Exception e) {
			//do nothing
			e.printStackTrace();
			return 0;
		}
		finally {
			conn.disconnect();
			conn = null;
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

		if (args.length != 2) {
			System.out.println("Usage: BenchMain <hostname> <iters_per_report>");
			return;
		}
		String servHostname = args[0];
		String baseURL = "http://" + servHostname + ":8001/";

		int report = Integer.parseInt(args[1]);
		int run = 100*report; 
		long start = System.currentTimeMillis();
		Client client = new Client();
		
		long success = 0;
		for (int i = 0; i <= run ; i++) {

			success += getPage(servHostname, baseURL, i % benchFiles.length);

			if (i % report == 0) {
				long curr = System.currentTimeMillis();
				System.out.print(i + "\t" + (curr - start) + "\tsuccess:" + success);
				try {
					String ret = client.queryMemory(servHostname, new Integer(i).toString());
					System.out.println("\t" + ret);
				} catch (Exception e) {
					System.err.println(e);
				}

			}
		}
	}

}
