package counters;

public aspect CountHash {
   int numCalls = 0;
   int numPut =0;
   int numRemove=0;
   int numGet=0;

   before () : call(* *..*(..)) && !within(counters.CountHash) 
     { numCalls++; }

   before () :  call(Object java.util.Hashtable.put(Object,Object)) && !within(counters.CountHash)
     { numPut++; }

   before () : call(Object java.util.Hashtable.remove(Object)) && !within(counters.CountHash)
     { numRemove++; }

   before () : call(* java.util.Hashtable.get(Object)) && !within(counters.CountHash)
     { numGet++; }

   after () : execution(static void *..main(String[])) {
       System.err.println(
	   "numCalls:     " + numCalls +
	   "\n  numAdd:    " + numPut  +  " ( " + (numPut*1.)/numCalls * 100 + ") " +
	   "\n  numRemove: " + numRemove + " ( " + (numRemove*1.)/numCalls * 100 + ") " +
	   "\n  numGet:    " + numGet + " ( " + (numGet*1.)/numCalls * 100 + ")");
   }
}
