import java.util.*;

public aspect RealHashSetWithLet {
    
  /**
  * This version is better in a way that it checks if the modification really changed the hash code
  * of the collection in question. Also it works for arbitrary objects, not just collections.
  * BUT it uses let().
  */
 tracematch(HashSet s, Object o, int hashCode) {
     
     sym add before : call(* Collection.add(Object)) && target(s) && args(o) && let(hashCode, o.hashCode());
     sym remove before : call(* Collection.remove(Object)) && target(s) && args(o);
     sym doesContain before: call(* Collection.contains(..)) && target(s) && args(o);

     add doesContain {

         if(hashCode!=o.hashCode()) {    
             System.out.println("HashCode changed for Object "+o+" while being in a HashSet.");
         } 

     }
 }
 
    
}
