//Listing 7.4 DBConnectionPoolingAspect.java

import java.sql.*;

public aspect DBConnectionPoolingAspect {
    pointcut connectionRelease(Connection connection)
	: call(public void Connection.close())
	&& target(connection);

    // cannot have more than one "replace" clause in a
    // PQL query, so we use an aspect to ignore calls
    // that would close a connection
    void around(Connection connection) : connectionRelease(connection)
    {
        /* don't release the connection */
    }
}
