//Listing 7.4 DBConnectionPoolingTM.java

import java.sql.*;

public aspect DBConnectionPoolingTM {
    pointcut connectionCreation(String url, String username,
				String password)
	: call(public static Connection
	       DriverManager.getConnection(String, String, String))
	&& args(url, username, password);

    pointcut connectionRelease(Connection connection)
	: call(public void Connection.close())
	&& target(connection);

    Connection tracematch(Connection connection, String url, String username, String password) {
        sym get_connection1 after returning(connection) : connectionCreation(url, username, password);
        sym get_connection2 around (url, username, password): connectionCreation(url, username, password);
        sym release_connection before: connectionRelease(connection); // could be after also

        get_connection1 release_connection get_connection2
        {
           return connection;
        }

    }

    void around() : connectionRelease(*) 
    {
    }
}
