import org.aspectj.lang.*;

public class LockTest {
    public static final void main(String[] argv) {
        a();
    }
    public static void a() {
        b();
    }
    public static void b() {
        new LockTest().lock();
    }
    public void lock() {
        System.out.println("locking");
    }
    public void unlock() {
        System.out.println("unlocking");
    }
}

aspect Tracematch {
    pointcut anyfunc() : execution(* a(..)) || execution(* b(..));
    pointcut enclosingExec(JoinPoint jp) :
        cflowbelow(anyfunc() && let(jp, thisJoinPoint));
    perthread tracematch(LockTest r, JoinPoint jp) {
        sym beforefunc before : 
               anyfunc() && let(jp, thisJoinPoint);
        sym afterfunc after : 
               anyfunc() && let(jp, thisJoinPoint);
        sym lock after : 
               call(* lock(..)) && target(r) && enclosingExec(jp);
        sym unlock after : 
               call(* unlock(..)) && target(r) && enclosingExec(jp);

        beforefunc lock afterfunc {
            System.out.println("locking error:"+jp);
	}
    }
}

