SIM_SRC=../SimBench/src/jsim:../SimBench/src/certrevsim
BENCH_CMD="time java certrevsim.Simulator 8 200 90 5 60 1 1"
MEM_CMD="java MemoryTracker 8 200 90 5 60 1 1"
ABC="java -Xmx1024M abc.main.Main"
TM="java -Xmx1024M abc.main.Main -ext abc.tm"
TMN="java -Xmx1024M abc.main.Main -ext abc.tm -debug noNegativeBindings"

echo -n "Cleaning..."
rm -rf aspectclasses tmclasses tmnnclasses
echo done

echo -n "Compiling...aspect..."
$ABC -d aspectclasses MemoryTracker.java NullTrack.java \
        -sourceroots $SIM_SRC >& /dev/null
echo -n "tm..."
$TM  -d tmclasses     MemoryTracker.java Tracematch.java \
        -sourceroots $SIM_SRC >& /dev/null
echo -n "tm (no negative bindings)..."
$TMN -d tmnnclasses   MemoryTracker.java Tracematch.java \
        -sourceroots $SIM_SRC >& /dev/null
echo done

echo -n "Benchmarking...aspect..."
CLASSPATH=${CLASSPATH}:aspectclasses $BENCH_CMD >& aspect.results
echo -n "tm..."
CLASSPATH=${CLASSPATH}:tmclasses $BENCH_CMD >& tm.results
echo -n "tm (no negative bindings)..."
CLASSPATH=${CLASSPATH}:tmnnclasses $BENCH_CMD >& tmnn.results
echo done

echo -n "Measuring memory usage...aspect..."
CLASSPATH=${CLASSPATH}:aspectclasses $MEM_CMD 2>aspect.mem 1>/dev/null
echo -n "tm..."
CLASSPATH=${CLASSPATH}:tmclasses $BENCH_CMD 2>tm.mem 1>/dev/null
echo -n "tm (no negative bindings)..."
CLASSPATH=${CLASSPATH}:tmnnclasses $BENCH_CMD 2>tmnn.mem 1>/dev/null
echo done
