import org.aspectj.lang.*;
import org.aspectj.lang.reflect.*;

public aspect Tracematch {

    pointcut weave() :
        execution(* abc.weaving.weaver.Weaver.weaveAdvice());
    
    pointcut unweave() :
        execution(* abc.weaving.weaver.Weaver.resetForReweaving());

    pointcut field(String f) :
        let(f, thisJoinPoint.getSignature().toString().intern());

    tracematch(Object o, String f)
    {
        sym weave before: set(* *) && target(o) && field(f) && cflow(weave());
        sym unweave before: set(* *) && target(o) && field(f) && cflow(unweave());
        sym start_reweave before: weave();
        sym read before: get(* *) && target(o) && field(f);

        weave read* start_reweave read
        {
            System.out.println("Forgot to unweave field "+f+
                    " of an object of type "+o.getClass());
        }
    }
}
