package benchmarks.methodpairs;

/**
 * Checks for matching method pairs.
 * 
 * @author Eric Bodden
 */
public abstract aspect MatchingMethodPairs {
    
    abstract pointcut firstMethod(Object o);
    abstract pointcut secondMethod(Object o);
    
    /* matches shutdown (see ajlib) */
    abstract pointcut shutDown();

    tracematch(Object o) {
        
        sym firstMethod before: firstMethod(o);
        sym secondMethod before: secondMethod(o);
        sym shutDown before: shutDown();

        //G(firstMethod -> F secondMethod)
        firstMethod shutDown {
        
            System.out.println("Matching closing method not found.");

        }

    }

}
